> For the complete documentation index, see [llms.txt](https://docs.tonic.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.tonic.ai/textual/tonic-textual-api/textual-python-sdk/textual-api-instantiate-sdk.md).

# Instantiating the SDK client

Whenever you call the Textual Python SDK, you first instantiate the SDK client.

To redact individual files, or to work with Textual datasets, you instantiate `TonicTextual`.

## Instantiating when the API key is already configured <a href="#api-key-configured" id="api-key-configured"></a>

If the API key is configured as the value of the [environment variable](/textual/textual-install-administer/configuring-textual/textual-env-var-configure.md) `TONIC_TEXTUAL_API_KEY`, then you do not need to provide the API key when you instantiate the SDK client.

For Textual datasets, or to use the `redact` method:

```python
from tonic_textual.redact_api import TextualNer
# The default URL is https://textual.tonic.ai (Textual Cloud)
# If you host Textual, provide your Textual URL
textual = TextualNer()
```

## Instantiating when the API key is not configured <a href="#api-key-not-configured" id="api-key-not-configured"></a>

If the API key is not configured as the value of the [environment variable](/textual/textual-install-administer/configuring-textual/textual-env-var-configure.md) `TONIC_TEXTUAL_API_KEY`, then you must include the API key in the request.

For Textual datasets, or to use the `redact` method:

```python
from tonic_textual.redact_api import TonicTextual
api_key = "your-tonic-textual-api-key"
# The default URL is https://textual.tonic.ai (Textual Cloud)
# If you host Textual, provide your Textual URL
textual = TonicTextual(api_key=api_key)
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.tonic.ai/textual/tonic-textual-api/textual-python-sdk/textual-api-instantiate-sdk.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
